#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <exec/types.h>
#include <exec/memory.h>
#include <libraries/dos.h>
#include <proto/dos.h>
#include <proto/exec.h>

#define Q_STFLG  0
#define Q_MSGNUM 1
#define Q_DATE   8
#define Q_BLOCKS 115
#define Q_CONF   123

USHORT Confs[100];
char BBSCode[9];

int GetCode(void);
int cnvrep(void);
USHORT RevS(USHORT);

int main(int argc, char **argv)
{
char flnam[20];
BPTR fhnd;
int er;

if(er=GetCode()) exit(er);

sprintf(flnam,"%s%s%s","READER:",BBSCode,".CNV");
if(!(fhnd=Open(flnam,MODE_OLDFILE))) {
  printf("\nCould not open %s for reading/n");
  exit(23);
}
Read(fhnd,&Confs[0],100*sizeof(USHORT));
Close(fhnd);

return(cnvrep());
}

int GetCode(void)
{
BPTR fhnd;
int fllen,ctr,k;
char *flbuf;

if(!(fhnd=Open("READERWORK:CONTROL.DAT", MODE_OLDFILE))) {
  printf("\nCould not open CONTROL.DAT for reading.\n");
  return(22);
}
Seek(fhnd,0,OFFSET_END);
fllen=Seek(fhnd,0,OFFSET_BEGINNING);

if(!(flbuf=AllocMem(fllen,0))) {
  printf("\nNo memory for CONTROL.DAT.\n");
  return(21);
}

Read(fhnd,flbuf,fllen);
Close(fhnd);

ctr=-1;
for(k=0;k<4;k++) {
  while(++ctr<fllen && *(flbuf+ctr)!='\n') {;}
}
while(++ctr<fllen && *(flbuf+ctr)!=',') {;}
++ctr;
memcpy(BBSCode,flbuf+ctr,8);
ctr=-1;
while(BBSCode[++ctr]!='\r') {;}
BBSCode[(ctr<8) ? ctr : 8]='\0';

FreeMem(flbuf,fllen);
return(0);
}

int cnvrep(void)
{
BPTR fhnd;
char *flbuf,flnam[24],tmp[25],dat[14],*cptr;
int fllen,ctr;
USHORT t;

time_t t1=time(NULL);
struct tm *tp=localtime(&t1);

if((++(tp->tm_mon))>12) tp->tm_mon=1;

strftime(dat,13,"%m-%d-%y%H:%M",tp);

sprintf(flnam,"%s%s%s","READERWORK:",BBSCode,".MSG");
if(!(fhnd=Open(flnam,MODE_OLDFILE))) {
  printf("\nNo Reply file found.\n");
  return(0);
}
Seek(fhnd,0,OFFSET_END);
fllen=Seek(fhnd,0,OFFSET_BEGINNING);

if(!(flbuf=AllocMem(fllen,0))) {
  printf("\nNo memory for reply file.\n");
  return(21);
}

Read(fhnd,flbuf,fllen);
Close(fhnd);

cptr=flbuf+128;

while(cptr<flbuf+fllen) {
  t=*(cptr+Q_CONF);

  if(t<100) {
    *(cptr+Q_CONF)=*((char *)&Confs[t]);
    *(cptr+Q_CONF+1)=*((char *)&Confs[t]+1);
    sprintf(tmp,"%u       ",RevS(Confs[t]));
    memcpy(cptr+Q_MSGNUM,tmp,7);
  }
  memcpy(cptr+Q_DATE,dat,13);
  memcpy(tmp,cptr+Q_BLOCKS,6);
  tmp[6]='\0';
  cptr+=atoi(tmp)*128;
}

if(!(fhnd=Open(flnam,MODE_NEWFILE))) {
  printf("\nCannot open %s for writing.\n",flnam);
  FreeMem(flbuf,fllen);
  return(22);
}

Write(fhnd,flbuf,fllen);
Close(fhnd);

FreeMem(flbuf,fllen);

return(0);
}

USHORT RevS(USHORT s)
{
union {
  USHORT S;
  char c[2];
} Sc;
char t;

Sc.S=s;
t=Sc.c[0];
Sc.c[0]=Sc.c[1];
Sc.c[1]=t;

return(Sc.S);

}
