#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <exec/types.h>
#include <exec/memory.h>
#include <libraries/dos.h>
#include <proto/dos.h>
#include <proto/exec.h>

#define Q_STFLG  0
#define Q_BLOCKS 116
#define Q_CONF   123

USHORT Confs[100];
char BBSCode[9];
int numcnf;

int cnvmsg(void);
USHORT RevS(USHORT);
int cnvctrl(void);
USHORT L2S(int);

int main(int argc, char **argv)
{
char flnam[20];
BPTR fhnd;
int er;

if(er=cnvctrl()) exit(er);

sprintf(flnam,"%s%s%s","READER:",BBSCode,".CNV");
if(!(fhnd=Open(flnam,MODE_NEWFILE))) {
  printf("\nCannot open %s for writing.\n",flnam);
  exit(22);
}
Write(fhnd,(char *)Confs,100*sizeof(USHORT));
Close(fhnd);

if(er=cnvmsg()) exit(er);
return(0);
}


   /*****************************************/
   /* Convert MESSAGES.DAT for Amiga Reader */
   /*****************************************/

int cnvmsg(void)
{
BPTR fhnd;
int fllen,ctr,k,j;
char *flbuf,*ctptr,tmp[10];
USHORT msgcnf;

if(!(fhnd=Open("READERWORK:MESSAGES.DAT", MODE_OLDFILE))) {
  printf("\nCould not open MESSAGES.DAT for reading.\n");
  return(21);
}
Seek(fhnd,0,OFFSET_END);
fllen=Seek(fhnd,0,OFFSET_BEGINNING);

if(!(flbuf=(char *)AllocMem(fllen,0))) {
  printf("\nNo memory for file.\n");
  Close(fhnd);
  return(22);
}

Read(fhnd,flbuf,fllen);
Close(fhnd);

ctr=128;
ctptr=flbuf+ctr;

while(*ctptr!='\0' && ctr<fllen) {
  msgcnf=*(ctptr+124)+((*(ctptr+123))<<8);
  for(k=0;k<=numcnf;k++){
    if(Confs[k]==msgcnf) {
      msgcnf=L2S(k);
      msgcnf=RevS(msgcnf);
      *(ctptr+Q_CONF)=*((char *)&msgcnf);
      *(ctptr+Q_CONF+1)=*((char *)&msgcnf+1);
      break;
    }
  }
  memcpy(tmp,ctptr+Q_BLOCKS,6);

  tmp[6]='\0';
  ctr+=atoi(tmp)*128;
  ctptr=flbuf+ctr;
}

if(!(fhnd=Open("READERWORK:MESSAGES.DAT", MODE_NEWFILE))) {
  printf("\nCould not open MESSAGES.DAT for writing.\n");
  FreeMem(flbuf,fllen);
  return(23);
}
Write(fhnd,flbuf,ctr);
Close(fhnd);
FreeMem(flbuf,fllen);
return(0);
}

  /****************************************/
  /*     Reverse byte order of USHORT     */
  /****************************************/

USHORT RevS(USHORT sptr)
{
union {
  USHORT S;
  char C[2];
} UC;
char ch;
UC.S=sptr;

ch=UC.C[1];
UC.C[1]=UC.C[0];
UC.C[0]=ch;

return(UC.S);
}

  /******************************************/
  /*  Convert CONTROL.DAT for Amiga-Reader  */
  /******************************************/

int cnvctrl(void)
{
int fllen,ctr,k,ctr2,namlen;
volatile int j;
BPTR fhnd;
char *flbuf,tmp[8],*cptr;


if(!(fhnd=Open("READERWORK:CONTROL.DAT",MODE_OLDFILE))) {
  printf("\nCould not open CONTROL.DAT for reading.\n");
  return (24);
}

Seek(fhnd,0,OFFSET_END);
fllen=Seek(fhnd,0,OFFSET_BEGINNING);
if(!(flbuf=(char *)AllocMem(fllen,0))) {
  printf("No mem for CONTROL.DAT\n");
  Close(fhnd);
  return(25);
}
Read(fhnd,flbuf,fllen);
Close(fhnd);

if(!(fhnd=Open("READERWORK:CONTROL.DAT",MODE_NEWFILE))) {
  printf("\nCould not open CONTROL.DAT for writing.\n");
  FreeMem(flbuf,fllen);
  return(26);
}

ctr=-1;
while(++ctr<fllen && *(flbuf+ctr)!='\r');
ctr2=ctr;
Write(fhnd,flbuf,(ctr>47) ? 47 : ctr);
for(k=1;k<=3;k++) {
  while(++ctr<fllen && *(flbuf+ctr)!='\r') ;
}			/* find end of fourth line */
ctr++;

k=0;
while(ctr++<fllen && *(flbuf+ctr)!=',') k++;
if (k!=5) {
  if(k<5) {
    Write(fhnd,flbuf+ctr2,ctr-ctr2);
    Write(fhnd,"     ",5-k);
  } else {
    Write(fhnd,flbuf+ctr2,ctr-k+5-ctr2);
  }
  ctr2=ctr;
}

memcpy(cptr=BBSCode,flbuf+ctr+1,8);
while(*cptr!='\r') cptr++;
*cptr='\0';

for(k=1;k<=6;k++) {
  while(ctr++<fllen && *(flbuf+ctr)!='\r') ;
}
memcpy(tmp,flbuf+ctr+2,5);
tmp[5]='\0';
numcnf=atoi(tmp);
while(ctr++<fllen && *(flbuf+ctr)!='\r') ;

for(k=0;k<=((numcnf<100) ? numcnf : 99);k++) {
  ctr+=2;
  j=atoi(flbuf+ctr);
  Write(fhnd,flbuf+ctr2,ctr-ctr2);
  sprintf(tmp,"%d",k);
  Write(fhnd,tmp,strlen(tmp));
  while(ctr++<fllen && *(flbuf+ctr)!='\r') {;}
  ctr2=ctr;
  ctr++;
  Confs[k]=L2S(j);
  Confs[k]=RevS(Confs[k]);

  namlen=0;
  while(ctr++<fllen && *(flbuf+ctr)!='\r') namlen++;
  if(namlen>10) {
    *(flbuf+ctr-namlen+10)='\0';
    Write(fhnd,flbuf+ctr2,strlen(flbuf+ctr2));
    ctr2=ctr;
  }
}

Write(fhnd,flbuf+ctr2,fllen-ctr2);
Close(fhnd);
FreeMem(flbuf,fllen);
return(0);
}

  /**************************************/
  /*  Return low word of int as USHORT  */
  /**************************************/

USHORT L2S(int iptr)
{
union {
  int L;
  USHORT S[2];
} LS;

LS.L=iptr;
return(LS.S[1]);
}
